//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SpeedButtonEx"
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
        : TForm(Owner)
{
 AccessElements(false);
 ScaleAccessElements(false);
 bBegin->Enabled = false;
 isRu = true;
}
//---------------------------------------------------------------------------
void TfmMain::RefreshKKMs()
 {
  int count;
  if(isRu)count = Driver.Exec(PropertyGet(""));
  else count = Driver.Exec(PropertyGet("DeviceCount"));
  for(int i=1;i<=count;i++)
   {
    Variant vv;
    if(isRu)Driver.Exec(Procedure("")<<i<<&vv);
    else Driver.Exec(Procedure("GetDeviceNameByNo")<<i<<&vv);
    eKKM->Items->Add(vv);
   }
 }
void TfmMain::RefreshScales()
 {
  int count;
  count = ScaleDriver.Exec(PropertyGet(""));
  for(int i=1;i<=count;i++)
   {
    Variant vv;
    ScaleDriver.Exec(Procedure("")<<i<<&vv);
    cbScale->Items->Add(vv);
   }
 }
void TfmMain::AccessElements(bool isOpen)
 {
   bBegin->Enabled = !isOpen;
   bClose->Enabled = isOpen;
   pSaveGoods->TabVisible = isOpen;
   pReport->TabVisible = isOpen;
   PanelInfo->Visible = isOpen;
 }
void TfmMain::ScaleAccessElements(bool isOpen)
 {
   bScaleBegin->Enabled = !isOpen;
   bScaleClose->Enabled = isOpen;
   pScaleSaveGoods->TabVisible = isOpen;
   ScalePanelInfo->Visible = isOpen;
 }

void __fastcall TfmMain::FormActivate(TObject *Sender)
{
  try{
  PageControl->ActivePage = pConfig;
  if(isRu)Driver = CreateOleObject("MercuryCOM.RU_KKMOFFLine");
  else Driver = CreateOleObject("MercuryCOM.KKMoffLine");
  RefreshKKMs();
  }catch(...)
  {
   ShowMessage("   (MercuryCOM.KKMoffLine)\n  (Drv_M_setup.exe)");
   Application->Terminate();
  }
  try{
  PageControl->ActivePage = pConfig;
  ScaleDriver = CreateOleObject("MercuryCOM.RU_ScaleOffLine");
  RefreshScales();
  }catch(...)
  {
   ShowMessage("   (MercuryCOM.RU_ScaleOffLine)\n  (Drv_M_setup.exe)");
   Application->Terminate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bEditECRClick(TObject *Sender)
{
  if(isRu)Driver.Exec(Procedure(""));
  else    Driver.Exec(Procedure("EditDeviceList"));
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::eKKMChange(TObject *Sender)
{
 if(eKKM->Text!="")
  {
   AnsiString InBoxDir;
   if(isRu)InBoxDir = Driver.Exec(PropertyGet(""));
   else InBoxDir = Driver.Exec(PropertyGet("InBoxDir"));
   if(InBoxDir!="")
    {
      if(isRu)Driver.Exec(Procedure(""));
      else Driver.Exec(Procedure("Close"));
    }
   AccessElements(false);
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
      if(isRu)Driver.Exec(Procedure(""));
      else Driver.Exec(Procedure("Close"));
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bBeginClick(TObject *Sender)
{
 if(isRu)
  {
   Driver.Exec(Procedure("")<<eKKM->Text);
   LIn->Caption = Driver.Exec(PropertyGet(""));
   LOut->Caption = Driver.Exec(PropertyGet(""));
  }else
  {
   Driver.Exec(Procedure("Open")<<eKKM->Text);
   LIn->Caption = Driver.Exec(PropertyGet("InBoxDir"));
   LOut->Caption = Driver.Exec(PropertyGet("OutBoxDir"));
  }
 AccessElements(true);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bCloseClick(TObject *Sender)
 {
   if(isRu)Driver.Exec(Procedure(""));
   else Driver.Exec(Procedure("Close"));
  AccessElements(false);
 }
//---------------------------------------------------------------------------
void __fastcall TfmMain::bTestGoodsClick(TObject *Sender)
{
 AnsiString InBoxDir;
 if(isRu)InBoxDir = Driver.Exec(PropertyGet(""));
 else InBoxDir = Driver.Exec(PropertyGet("InBoxDir"));
 mTest->Lines->SaveToFile(InBoxDir+"\\data.xml");

 if(isRu)Driver.Exec(Procedure("__"));
 else Driver.Exec(Procedure("UpdateWares"));
 AnsiString OperResult;
 if(isRu)OperResult = Driver.Exec(PropertyGet(""));
 else OperResult = Driver.Exec(PropertyGet("OperResult"));
 if(OperResult == "ERROR")
  {
    AnsiString LastError;
    if(isRu) LastError = Driver.Exec(PropertyGet(""));
    else LastError = Driver.Exec(PropertyGet("LastError"));
    ShowMessage(":"+LastError);
  }else ShowMessage("  ");
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bNullGoodsClick(TObject *Sender)
{
 AnsiString s = mTest->Lines->Text;
 mTest->Lines->Text = "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n" \
   "<INCOTEX_MERCURY_CASHER_OFFLINE_UPDATE VERSION=\"1.0.1\" MODE=\"CLEAR_BEFORE\">\n" \
   " <WARES>\n" \
   " </WARES>\n" \
   "</INCOTEX_MERCURY_CASHER_OFFLINE_UPDATE>\n" ;
 bTestGoodsClick(0);
 mTest->Lines->Text = s;
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::bReportClick(TObject *Sender)
{
  AnsiString OutBoxDir;
  if(isRu)OutBoxDir = Driver.Exec(PropertyGet(""));
  else OutBoxDir = Driver.Exec(PropertyGet("OutBoxDir"));
  if(FileExists(OutBoxDir+"\\data.xml"))
   {
     mReport->Lines->LoadFromFile(OutBoxDir+"\\data.xml");
     ShowMessage(":    ");
     DeleteFileA(OutBoxDir+"\\data.xml");
     return;
   }
  if(isRu)Driver.Exec(Procedure(""));
  else Driver.Exec(Procedure("CollectReport"));
  AnsiString OperResult;
  if(isRu)OperResult = Driver.Exec(PropertyGet(""));
  else OperResult = Driver.Exec(PropertyGet("OperResult"));
  if(OperResult == "ERROR")
   {
    AnsiString LastError;
    if(isRu)LastError = Driver.Exec(PropertyGet(""));
    else LastError = Driver.Exec(PropertyGet("LastError"));
    ShowMessage(":"+LastError);
   }else
   {
    mReport->Lines->LoadFromFile(OutBoxDir+"\\data.xml");
    ShowMessage("  ");
    DeleteFileA(OutBoxDir+"\\data.xml");
   }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::cbScaleChange(TObject *Sender)
{
 if(cbScale->Text!="")
  {
   AnsiString InBoxDir;
   InBoxDir = ScaleDriver.Exec(PropertyGet(""));
   if(InBoxDir!="")
    {
      ScaleDriver.Exec(Procedure(""));
    }
   ScaleAccessElements(false);
  }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButtonEx1Click(TObject *Sender)
{
  ScaleDriver.Exec(Procedure(""));
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bScaleBeginClick(TObject *Sender)
{
   ScaleDriver.Exec(Procedure("")<<cbScale->Text);
   lScaleIn->Caption = ScaleDriver.Exec(PropertyGet(""));
   ScaleAccessElements(true);
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bScaleCloseClick(TObject *Sender)
{
  ScaleDriver.Exec(Procedure(""));
  ScaleAccessElements(false);
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::SpeedButtonEx5Click(TObject *Sender)
{
 AnsiString s = mTestScale->Lines->Text;
 mTestScale->Lines->Text = "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n" \
   "<INCOTEX_MERCURY_CASHER_OFFLINE_UPDATE VERSION=\"1.0.1\" MODE=\"CLEAR_BEFORE\">\n" \
   " <WARES>\n" \
   " </WARES>\n" \
   "</INCOTEX_MERCURY_CASHER_OFFLINE_UPDATE>\n" ;
 bSendWaresToScaleClick(0);
 mTestScale->Lines->Text = s;
        
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::bSendWaresToScaleClick(TObject *Sender)
{
 AnsiString InBoxDir;
 InBoxDir = ScaleDriver.Exec(PropertyGet(""));
 mTestScale->Lines->SaveToFile(InBoxDir+"\\data.xml");
 ScaleDriver.Exec(Procedure("__"));
 AnsiString OperResult;
 OperResult = ScaleDriver.Exec(PropertyGet(""));
 if(OperResult == "ERROR")
  {
    AnsiString LastError;
    LastError = ScaleDriver.Exec(PropertyGet(""));
    ShowMessage(":"+LastError);
  }else ShowMessage("  ");
}
//---------------------------------------------------------------------------

